//-------------------------------------------------------------------+
//                  LOCK_Extend-Mod-Delete_Rectangles-ver03.mq4      |
//-------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                       LOCK MADE 2015_09_13       |
//+------------------------------------------------------------------+

#property copyright "LOCK"
#property version "3.00"

#property description "Move rectangles to the right at a certain specified value from current bar, selecting them by color."
#property description "Delete rectangles or change their colors if price fills the rectangles, selecting them by color."
#property description "The rules for the above actions come from some of the most important JD teachings."
#property description "Move forward reference rectangles"


#property indicator_chart_window

//--- input parameters
extern string    SessionTimesInfo           ="Set the Start time for each session.";
extern string    DayStartTime               ="01:00";
extern string    AsiaStartTime              ="03:00";
extern string    GBStartTime                ="10:00";
extern string    USStartTime                ="15:00";
extern string    USPitStartTime             ="16:30";
extern string    SydneyStartTime            ="00:00";
//-----------------------------------------------------------------------------REFERENCE RECTANGLES
extern int       RefMoveRectangleRight      = 100;
//-----------------------------------------------------------------------------ANOMALIES
extern string    AnomalieslevelcolorsInfo   ="Set colors & extesion for Anomalies.";
extern color     GBAnRectangleColor         = IndianRed;//C'205,92,92';
extern color     DGBAnRectangleColor        = C'215,125,125';
extern int       GBAnMoveRectangleRight     = 420;
extern color     USPitAnRectangleColor      = Crimson;//C'220,20,60';
extern color     DUSPitAnRectangleColor     = C'236,47,85';
extern int       USPitAnMoveRectangleRight  = 430;
//-----------------------------------------------------------------------------STOPS
extern string    STOPSlevelcolorsInfo       ="Set colors & extesion for each stop.";
extern color     ASYStopsRectangleColor     = SaddleBrown;//C'129,69,19';
extern color     DASYStopsRectangleColor    = C'175,88,24';
extern int       ASYStopsMoveRectangleRight = 440;
extern color     GBStopsRectangleColor      = FireBrick;//C'178,34,34';
extern color     DGBStopsRectangleColor     = C'215,40,40';
extern int       GBStopsMoveRectangleRight  = 450;
extern color     TGBStopsRectangleColor     = Tomato;//C'255,99,71';
extern color     DTGBStopsRectangleColor    = C'255,134,113';
extern int       TGBStopsMoveRectangleRight = 460;
extern color     USStopsRectangleColor      = Sienna;//C'160,82,45';
extern color     DUSStopsRectangleColor     = C'192,99,54';
extern int       USStopsMoveRectangleRight  = 470;
extern color     TUSStopsRectangleColor     = OrangeRed;//C'255,69,0';
extern color     DTUSStopsRectangleColor    = C'255,101,43';
extern int       TUSStopsMoveRectangleRight = 480;
extern color     USPStopsRectangleColor     = Maroon;//C'128,0,0';
extern color     DUSPStopsRectangleColor    = C'170,0,0';
extern int       USPStopsMoveRectangleRight = 490;
extern color     TUSPStopsRectangleColor    = Brown;//C'165,42,42';
extern color     DTUSPStopsRectangleColor   = C'204,51,51';
extern int       TUSPStopsMoveRectangleRight= 500;

//-----------------------------------------------------------------------------GAPS
extern string    GAPSlevelcolorsInfo        ="Set colors & extesion for each gap.";
extern color     GBGapRectangleColor        = Navy;//C'0,0,128';
extern color     DGBGapRectangleColor       = C'0,0,170';
extern int       GBGapMoveRectangleRight    = 510;
extern color     USGapRectangleColor        = C'31,52,52';
extern color     DUSGapRectangleColor       = C'45,74,74';
extern int       USGapMoveRectangleRight    = 520;
extern color     USPitGapRectangleColor     = DarkSlateGray;//C'47,79,79';
extern color     DUSPitGapRectangleColor    = C'64,106,106';
extern int       USPitGapMoveRectangleRight = 530;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
 {
  Comment  ("\n\n\n\n\n\nExtend-Mod-Delete_Rectangles \nACTIVATED");    // comment in the upper left corner  
  return(0);
 }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() 

 {
  double H = High[0], L = Low[0]; 


  int RectTime;   
  if(TimeCurrent() > RectTime && (NewBar() == true))
   {
     for(int TST = ObjectsTotal()-1; TST >= 0; TST--) 
     {
       string StRect = ObjectName(TST); 
//--ANOMALIES----------------------------------------------------------------------------------------------------        
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == GBAnRectangleColor)      //--Find and move rectangles  
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+GBAnMoveRectangleRight*10*Period());                //--selecting them by color
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == DGBAnRectangleColor)
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+GBAnMoveRectangleRight*10*Period());
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == USPitAnRectangleColor)
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+USPitAnMoveRectangleRight*10*Period()); 
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == DUSPitAnRectangleColor)
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+USPitAnMoveRectangleRight*10*Period());      
//--REFERENCE RECTANGLES-----------------------------------------------------------------------------------------
            if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == Khaki) {
              ObjectSet(StRect, OBJPROP_TIME1, TimeCurrent()+RefMoveRectangleRight*10*Period()); 
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+RefMoveRectangleRight*15*Period());  
              } 
            if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == DarkKhaki) {
              ObjectSet(StRect, OBJPROP_TIME1, TimeCurrent()+RefMoveRectangleRight*10*Period()); 
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+RefMoveRectangleRight*15*Period());  
              }
            if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == Magenta) {
              ObjectSet(StRect, OBJPROP_TIME1, TimeCurrent()+RefMoveRectangleRight*10*Period()); 
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+RefMoveRectangleRight*15*Period());  
              }
            if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == Aqua) {
              ObjectSet(StRect, OBJPROP_TIME1, TimeCurrent()+RefMoveRectangleRight*10*Period()); 
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+RefMoveRectangleRight*15*Period());  
              }
            if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == DodgerBlue) {
              ObjectSet(StRect, OBJPROP_TIME1, TimeCurrent()+RefMoveRectangleRight*10*Period()); 
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+RefMoveRectangleRight*15*Period());  
              }
//--STOPS--------------------------------------------------------------------------------------------------------           
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == ASYStopsRectangleColor)                
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+ASYStopsMoveRectangleRight*10*Period());
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == DASYStopsRectangleColor)                
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+ASYStopsMoveRectangleRight*10*Period());
//--GB-stops-----------------------------------------------------------------------------------------------------               
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == GBStopsRectangleColor)                
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+GBStopsMoveRectangleRight*10*Period());  
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == DGBStopsRectangleColor)                
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+GBStopsMoveRectangleRight*10*Period());  
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == TGBStopsRectangleColor)                
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+TGBStopsMoveRectangleRight*10*Period());  
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == DTGBStopsRectangleColor)                
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+TGBStopsMoveRectangleRight*10*Period());  
//--US-stops-----------------------------------------------------------------------------------------------------               
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == USStopsRectangleColor)                
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+USStopsMoveRectangleRight*10*Period());  
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == DUSStopsRectangleColor)                
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+USStopsMoveRectangleRight*10*Period());  
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == TUSStopsRectangleColor)                
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+TUSStopsMoveRectangleRight*10*Period());  
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == DTUSStopsRectangleColor)                
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+TUSStopsMoveRectangleRight*10*Period());  
//--US Pit-stops-------------------------------------------------------------------------------------------------                     
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == USPStopsRectangleColor)                
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+USPStopsMoveRectangleRight*10*Period()); 
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == DUSPStopsRectangleColor)                
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+USPStopsMoveRectangleRight*10*Period()); 
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == TUSPStopsRectangleColor)                           
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+TUSPStopsMoveRectangleRight*10*Period()); 
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == DTUSPStopsRectangleColor)                           
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+TUSPStopsMoveRectangleRight*10*Period());        
//--GAPS----------------------------------------------------------------------------------------------------------           
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == GBGapRectangleColor)       
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+GBGapMoveRectangleRight*10*Period()); 
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == DGBGapRectangleColor)       
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+GBGapMoveRectangleRight*10*Period());   
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == USGapRectangleColor)
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+USGapMoveRectangleRight*10*Period());            
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == DUSGapRectangleColor)
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+USGapMoveRectangleRight*10*Period()); 
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == USPitGapRectangleColor)
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+USPitGapMoveRectangleRight*10*Period());            
           if(ObjectType(StRect) == OBJ_RECTANGLE && ObjectGet(StRect,OBJPROP_COLOR) == DUSPitGapRectangleColor)
              ObjectSet(StRect, OBJPROP_TIME2, TimeCurrent()+USPitGapMoveRectangleRight*10*Period());                                                  
               {
               double StRectHigh       = ObjectGet(StRect, OBJPROP_PRICE2);
               double StRectLow        = ObjectGet(StRect, OBJPROP_PRICE1);
               int    OBJrectangle     = ObjectType(StRect) == OBJ_RECTANGLE;
//--colors for ANOMALIES- 
               color GBAnColProp       = (ObjectGet(StRect,OBJPROP_COLOR)  == GBAnRectangleColor);
               color DGBAnColProp      = (ObjectGet(StRect,OBJPROP_COLOR)  == DGBAnRectangleColor);
               color USPAnColProp      = (ObjectGet(StRect,OBJPROP_COLOR)  == USPitAnRectangleColor);
               color DUSPAnColProp     = (ObjectGet(StRect,OBJPROP_COLOR)  == DUSPitAnRectangleColor);
//--colors for STOPS-               
               color ASYStopsColProp   = (ObjectGet(StRect,OBJPROP_COLOR)  == ASYStopsRectangleColor);
               color DASYStopsColProp  = (ObjectGet(StRect,OBJPROP_COLOR)  == DASYStopsRectangleColor);
               color GBStopsColProp    = (ObjectGet(StRect,OBJPROP_COLOR)  == GBStopsRectangleColor);
               color DGBStopsColProp   = (ObjectGet(StRect,OBJPROP_COLOR)  == DGBStopsRectangleColor);
               color TGBStopsColProp   = (ObjectGet(StRect,OBJPROP_COLOR)  == TGBStopsRectangleColor);
               color DTGBStopsColProp  = (ObjectGet(StRect,OBJPROP_COLOR)  == DTGBStopsRectangleColor);
               color USStopsColProp    = (ObjectGet(StRect,OBJPROP_COLOR)  == USStopsRectangleColor);
               color DUSStopsColProp   = (ObjectGet(StRect,OBJPROP_COLOR)  == DUSStopsRectangleColor);
               color TUSStopsColProp   = (ObjectGet(StRect,OBJPROP_COLOR)  == TUSStopsRectangleColor);
               color DTUSStopsColProp  = (ObjectGet(StRect,OBJPROP_COLOR)  == DTUSStopsRectangleColor);
               color USPStopsColProp   = (ObjectGet(StRect,OBJPROP_COLOR)  == USPStopsRectangleColor);
               color DUSPStopsColProp  = (ObjectGet(StRect,OBJPROP_COLOR)  == DUSPStopsRectangleColor);
               color TUSPStopsColProp  = (ObjectGet(StRect,OBJPROP_COLOR)  == TUSPStopsRectangleColor);
               color DTUSPStopsColProp = (ObjectGet(StRect,OBJPROP_COLOR)  == DTUSPStopsRectangleColor);
//--colors for GAPS-               
               color GBGapColPro       = (ObjectGet(StRect,OBJPROP_COLOR)  == GBGapRectangleColor);
               color DGBGapColPro      = (ObjectGet(StRect,OBJPROP_COLOR)  == DGBGapRectangleColor);
               color USGapColProp      = (ObjectGet(StRect,OBJPROP_COLOR)  == USGapRectangleColor);
               color DUSGapColProp     = (ObjectGet(StRect,OBJPROP_COLOR)  == DUSGapRectangleColor);
               color USPGapColProp     = (ObjectGet(StRect,OBJPROP_COLOR)  == USPitGapRectangleColor);
               color DUSPGapColProp    = (ObjectGet(StRect,OBJPROP_COLOR)  == DUSPitGapRectangleColor);                           
               }
           if ((H >= StRectLow) && (H >= StRectHigh) && (!OtherSes()) && (OBJrectangle) && (ASYStopsColProp))                         
               ObjectDelete(StRect);
           if ((L <= StRectLow) && (L <= StRectHigh) && (!OtherSes()) && (OBJrectangle) && (DASYStopsColProp))                         
               ObjectDelete(StRect);
           if ((H >= StRectLow) && (H >= StRectHigh) && (!GBSes()) && (OBJrectangle) && ((GBAnColProp)||(ASYStopsColProp)||(GBStopsColProp)||(TGBStopsColProp)||(GBGapColPro)))                         
               ObjectDelete(StRect); 
           if ((L <= StRectLow) && (L <= StRectHigh) && (!GBSes()) && (OBJrectangle) && ((DGBAnColProp)||(DASYStopsColProp)||(DGBStopsColProp)||(DTGBStopsColProp)||(DGBGapColPro)))                         
               ObjectDelete(StRect); 
           if ((H >= StRectLow) && (H >= StRectHigh) && (!USSes()) && (OBJrectangle) && ((GBAnColProp)||(ASYStopsColProp)||(GBStopsColProp)||(TGBStopsColProp)
           ||(USStopsColProp)||(TUSStopsColProp)||(USGapColProp)))                         
               ObjectDelete(StRect); 
           if ((L <= StRectLow) && (L <= StRectHigh) && (!USSes()) && (OBJrectangle) && ((DGBAnColProp)||(DASYStopsColProp)||(DGBStopsColProp)||(DTGBStopsColProp)
           ||(DUSStopsColProp)||(DTUSStopsColProp)||(DUSGapColProp)))                         
               ObjectDelete(StRect);               
           if ((H >= StRectLow) && (H >= StRectHigh) && (!UsPitSes()) && (OBJrectangle)  
              && ((GBAnColProp)||(USPAnColProp)||(ASYStopsColProp)||(GBStopsColProp)||(TGBStopsColProp)||(USStopsColProp)||(TUSStopsColProp)||(USGapColProp)||(USPStopsColProp)||(TUSPStopsColProp)||(USPGapColProp)))           
               ObjectDelete(StRect);
           if ((L <= StRectLow) && (L <= StRectHigh) && (!UsPitSes()) && (OBJrectangle) 
              && ((DGBAnColProp)||(DUSPAnColProp)||(DASYStopsColProp)||(DGBStopsColProp)||(DTGBStopsColProp)||(DUSStopsColProp)||(DTUSStopsColProp)||(DUSGapColProp)||(DUSPStopsColProp)||(DTUSPStopsColProp)||(DUSPGapColProp)))           
               ObjectDelete(StRect);
           if ((H >= StRectLow) && (H >= StRectHigh) && (GBStopsColProp)&& (OBJrectangle) && (!OtherSes())) 
               ObjectSet(StRect, OBJPROP_COLOR, TGBStopsRectangleColor);
           if ((L <= StRectLow) && (L <= StRectHigh) && (DGBStopsColProp) && (OBJrectangle) && (!OtherSes()))
               ObjectSet(StRect, OBJPROP_COLOR, DTGBStopsRectangleColor);    
           if ((H >= StRectLow) && (H >= StRectHigh) && (USStopsColProp) && (OBJrectangle) && ((!OtherSes())||(!GBSes())))  
               ObjectSet(StRect, OBJPROP_COLOR, TUSStopsRectangleColor);
           if ((L <= StRectLow) && (L <= StRectHigh) && (DUSStopsColProp) && (OBJrectangle) && ((!OtherSes())||(!GBSes()))) 
               ObjectSet(StRect, OBJPROP_COLOR, DTUSStopsRectangleColor);
           if ((H >= StRectLow) && (H >= StRectHigh) && (USPStopsColProp) && (OBJrectangle) && ((!OtherSes())||(!GBSes())||(!USSes()))) 
               ObjectSet(StRect, OBJPROP_COLOR, TUSPStopsRectangleColor);
           if ((L <= StRectLow) && (L <= StRectHigh) && (DUSPStopsColProp) && (OBJrectangle) && ((!OtherSes())||(!GBSes())||(!USSes()))) 
               ObjectSet(StRect, OBJPROP_COLOR, DTUSPStopsRectangleColor);             
               RectTime = TimeCurrent();
      }
   }

  return (0);
 }

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
 {
Comment  ("\n\n\n\n\n\nExtend-Mod-Delete_Rectangles \nCLOSED");    // comment in the upper left corner  
  return (0);
 }

//+------------------------------------------------------------------+
//| Session times definition                                         |
//+------------------------------------------------------------------+

bool NewBar()
{
static datetime lastbar;
datetime curbar = Time[0];
if(lastbar!=curbar)
{
lastbar=curbar;
return (true);
}
else
{
return(false);
}
}

bool OtherSes() 
  {
   
   string today = TimeToStr(TimeCurrent(),TIME_DATE);
   datetime Current_Time = TimeCurrent();
   datetime Sydopen = StrToTime(today+" "+SydneyStartTime);
   datetime GBopen  = StrToTime(today+" "+GBStartTime);   
      
   if ( Sydopen < GBopen )
      if ( (Current_Time < Sydopen) || (Current_Time >= GBopen) ) return(true);
      
   if ( Sydopen > GBopen )
      if ( (Current_Time < Sydopen) && (Current_Time >= GBopen) ) return(true);
      
   return(false);
   } 
   
bool GBSes() 
  {
   
   string today = TimeToStr(TimeCurrent(),TIME_DATE);
   datetime Current_Time = TimeCurrent();
   datetime GBopen = StrToTime(today+" "+GBStartTime);
   datetime USopen = StrToTime(today+" "+USStartTime);   
      
   if ( GBopen < USopen )
      if ( (Current_Time < GBopen) || (Current_Time >= USopen) ) return(true);
      
   if ( GBopen > USopen )
      if ( (Current_Time < GBopen) && (Current_Time >= USopen) ) return(true);
      
   return(false);
   }  

bool USSes() 
  {
   
   string today = TimeToStr(TimeCurrent(),TIME_DATE);
   datetime Current_Time = TimeCurrent();
   datetime USopen  = StrToTime(today+" "+USStartTime);
   datetime USPopen = StrToTime(today+" "+USPitStartTime);   
      
   if ( USopen < USPopen )
      if ( (Current_Time < USopen) || (Current_Time >= USPopen) ) return(true);
      
   if ( USopen > USPopen )
      if ( (Current_Time < USopen) && (Current_Time >= USPopen) ) return(true);
      
   return(false);
   }  
   
bool UsPitSes() 
  {
   
   string today = TimeToStr(TimeCurrent(),TIME_DATE);
   datetime Current_Time = TimeCurrent();
   datetime USPopen = StrToTime(today+" "+USPitStartTime);
   datetime Sydopen = StrToTime(today+" "+SydneyStartTime);   
      
   if ( USPopen < Sydopen )
      if ( (Current_Time < USPopen) || (Current_Time >= Sydopen) ) return(true);
      
   if ( USPopen > Sydopen )
      if ( (Current_Time < USPopen) && (Current_Time >= Sydopen) ) return(true);
      
   return(false);
   }    
   

   
  